## ros-r2b2-amcl 1.14.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(amcl)

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()
if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra)
endif()

find_package(ament_cmake_auto REQUIRED)
find_package(ament_cmake_ros REQUIRED)
set(required_dependencies
  "geometry_msgs"
  "nav_msgs"
  "rclcpp"
  "rcutils"
  "sensor_msgs"
  "std_srvs"
  "tf2"
  "tf2_geometry_msgs"
  "tf2_msgs"
  "tf2_ros"
)
ament_auto_find_build_dependencies(REQUIRED ${required_dependencies})

# dynamic reconfigure
# generate_dynamic_reconfigure_options(
#     cfg/AMCL.cfg
# )

include_directories(include/amcl include/amcl/map include/amcl/sensors include/amcl/pf)

ament_auto_add_library(amcl_pf
                    src/amcl/pf/pf.c
                    src/amcl/pf/pf_kdtree.c
                    src/amcl/pf/pf_pdf.c
                    src/amcl/pf/pf_vector.c
                    src/amcl/pf/eig3.c
                    src/amcl/pf/pf_draw.c)

ament_auto_add_library(amcl_map
                    src/amcl/map/map.c
                    src/amcl/map/map_cspace.cpp
                    src/amcl/map/map_range.c
                    src/amcl/map/map_store.c
                    src/amcl/map/map_draw.c)

ament_target_dependencies(amcl_map)
ament_auto_add_library(amcl_sensors
                    src/amcl/sensors/amcl_sensor.cpp
                    src/amcl/sensors/amcl_odom.cpp
                    src/amcl/sensors/amcl_laser.cpp)


ament_auto_add_executable(amcl
                       src/amcl_node.cpp)
# add_dependencies(amcl amcl_gencfg)

ament_target_dependencies(amcl
  "geometry_msgs"
  "nav_msgs"
  "rclcpp"
  "sensor_msgs"
  "std_srvs"
  "tf2"
  "tf2_geometry_msgs"
  "tf2_msgs"
  "tf2_ros")

target_link_libraries(amcl
    amcl_sensors amcl_map amcl_pf
)

install(DIRECTORY examples/
    DESTINATION share/${PROJECT_NAME}/examples
)

## Configure Tests
#if(CATKIN_ENABLE_TESTING)
#  find_package(rostest REQUIRED)
#
#  # Bags
#  catkin_download_test_data(${PROJECT_NAME}_basic_localization_stage_indexed.bag
#    http://download.ros.org/data/amcl/basic_localization_stage_indexed.bag
#    DESTINATION ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_SHARE_DESTINATION}/test
#    MD5 41fe43af189ec71e5e48eb9ed661a655)
#  catkin_download_test_data(${PROJECT_NAME}_global_localization_stage_indexed.bag
#    http://download.ros.org/data/amcl/global_localization_stage_indexed.bag
#    DESTINATION ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_SHARE_DESTINATION}/test
#    MD5 752f711cf4f6e8d1d660675e2da096b0)
#  catkin_download_test_data(${PROJECT_NAME}_small_loop_prf_indexed.bag
#    http://download.ros.org/data/amcl/small_loop_prf_indexed.bag
#    DESTINATION ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_SHARE_DESTINATION}/test
#    MD5 e4ef0fc006872b43f12ed8a7ce7dcd81)
#  catkin_download_test_data(${PROJECT_NAME}_small_loop_crazy_driving_prg_indexed.bag
#    http://download.ros.org/data/amcl/small_loop_crazy_driving_prg_indexed.bag
#    DESTINATION ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_SHARE_DESTINATION}/test
#    MD5 4a58d1a7962914009d99000d06e5939c)
#  catkin_download_test_data(${PROJECT_NAME}_texas_greenroom_loop_indexed.bag
#    http://download.ros.org/data/amcl/texas_greenroom_loop_indexed.bag
#    DESTINATION ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_SHARE_DESTINATION}/test
#    MD5 6e3432115cccdca1247f6c807038e13d)
#  catkin_download_test_data(${PROJECT_NAME}_texas_willow_hallway_loop_indexed.bag
#    http://download.ros.org/data/amcl/texas_willow_hallway_loop_indexed.bag
#    DESTINATION ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_SHARE_DESTINATION}/test
#    MD5 27deb742fdcd3af44cf446f39f2688a8)
#  catkin_download_test_data(${PROJECT_NAME}_rosie_localization_stage.bag
#    http://download.ros.org/data/amcl/rosie_localization_stage.bag
#    DESTINATION ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_SHARE_DESTINATION}/test
#    MD5 3347bf3835724cfa45e958c5c1846066)
#
#  # Maps
#  catkin_download_test_data(${PROJECT_NAME}_willow-full.pgm
#    http://download.ros.org/data/amcl/willow-full.pgm
#    DESTINATION ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_SHARE_DESTINATION}/test
#    MD5 b84465cdbbfe3e2fb9eb4579e0bcaf0e)
#  catkin_download_test_data(${PROJECT_NAME}_willow-full-0.05.pgm
#    http://download.ros.org/data/amcl/willow-full-0.05.pgm
#    DESTINATION ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_SHARE_DESTINATION}/test
#    MD5 b61694296e08965096c5e78611fd9765)
#
#  # Tests
#  add_rostest(test/set_initial_pose.xml)
#  add_rostest(test/set_initial_pose_delayed.xml)
#  add_rostest(test/basic_localization_stage.xml)
#  add_rostest(test/small_loop_prf.xml)
#  add_rostest(test/small_loop_crazy_driving_prg.xml)
#  add_rostest(test/texas_greenroom_loop.xml)
#  add_rostest(test/rosie_multilaser.xml)
#  add_rostest(test/texas_willow_hallway_loop.xml)
#
## Not sure when or if this actually passed.
##
## The point of this is that you start with an even probability
## distribution over the whole map and the robot localizes itself after
## some number of iterations of sensing and motion.
##
##  add_rostest(test/global_localization_stage.xml)
#endif()
ament_auto_package()

=== debian/changelog ===
ros-r2b2-amcl (1.14.0-3xenial) xenial; urgency=high

  * Allow AMCL to run from bag file to allow very fast testing.
  * Fixes interpretation of a delayed initialpose message (see #424 <https://github.com/ros-planning/navigation/issues/424>).
    The tf lookup as it was before this change was very likely to fail as
    ros::Time::now() was used to look up a tf without waiting on the tf's
    availability. Additionally, the computation of the "new pose" by
    multiplying the delta that the robot moved from the initialpose's
    timestamp to ros::Time::now() was wrong. That delta has to by multiplied
    from the right to the "old pose".
    This commit also changes the reference frame to look up this delta to be
    the odom frame as this one is supposed to be smooth and therefore the
    best reference to get relative robot motion in the robot (base link) frame.
  * New unit test for proper interpretation of a delayed initialpose message.
    Modifies the set_pose.py script to be able to send an initial pose with
    a user defined time stamp at a user defined time. Adds a rostest to
    exercise this new option.
    This reveals the issues mentioned in #424 <https://github.com/ros-planning/navigation/issues/424> (the new test fails).
  * Contributors: Derek King, Stephan Wirth

 -- David V. Lu!! <davidvlu@gmail.com>  Fri, 20 May 2016 04:00:00 -0000

ros-r2b2-amcl (1.13.1-3xenial) xenial; urgency=high

  * adds the set_map service to amcl
  * fix pthread_mutex_lock on shutdown
  * Contributors: Michael Ferguson, Stephan Wirth

 -- David V. Lu!! <davidvlu@gmail.com>  Thu, 29 Oct 2015 04:00:00 -0000

ros-r2b2-amcl (1.13.0-3xenial) xenial; urgency=high

  * amcl_node will now save latest pose on shutdown
  * Contributors: Ian Danforth

 -- David V. Lu!! <davidvlu@gmail.com>  Tue, 17 Mar 2015 04:00:00 -0000

ros-r2b2-amcl (1.12.0-3xenial) xenial; urgency=high

  * update maintainer email
  * Contributors: Michael Ferguson

 -- David V. Lu!! <davidvlu@gmail.com>  Wed, 04 Feb 2015 05:00:00 -0000

ros-r2b2-amcl (1.11.15-3xenial) xenial; urgency=high



 -- David V. Lu!! <davidvlu@gmail.com>  Tue, 03 Feb 2015 05:00:00 -0000

ros-r2b2-amcl (1.11.14-3xenial) xenial; urgency=high



 -- David V. Lu!! <davidvlu@gmail.com>  Fri, 05 Dec 2014 05:00:00 -0000

ros-r2b2-amcl (1.11.13-3xenial) xenial; urgency=high



 -- David V. Lu!! <davidvlu@gmail.com>  Thu, 02 Oct 2014 04:00:00 -0000

ros-r2b2-amcl (1.11.12-3xenial) xenial; urgency=high

  * Bug fix to remove particle weights being reset when motion model is updated
  * Integrated new sensor model which calculates the observation likelihood in a probabilistic manner
    Also includes the option to do beam-skipping (to better handle observations from dynamic obstacles)
  * Pose pulled from parameter server when new map received
  * Contributors: Steven Kordell, hes3pal

 -- David V. Lu!! <davidvlu@gmail.com>  Wed, 01 Oct 2014 04:00:00 -0000

ros-r2b2-amcl (1.11.11-3xenial) xenial; urgency=high



 -- David V. Lu!! <davidvlu@gmail.com>  Wed, 23 Jul 2014 04:00:00 -0000

ros-r2b2-amcl (1.11.10-3xenial) xenial; urgency=high



 -- David V. Lu!! <davidvlu@gmail.com>  Wed, 25 Jun 2014 04:00:00 -0000

ros-r2b2-amcl (1.11.9-3xenial) xenial; urgency=high



 -- David V. Lu!! <davidvlu@gmail.com>  Tue, 10 Jun 2014 04:00:00 -0000

ros-r2b2-amcl (1.11.8-3xenial) xenial; urgency=high



 -- David V. Lu!! <davidvlu@gmail.com>  Wed, 21 May 2014 04:00:00 -0000

ros-r2b2-amcl (1.11.7-3xenial) xenial; urgency=high

  * removes useless this->z_max = z_max assignment
  * Fix warning string.
  * Contributors: Jeremiah Via, enriquefernandez

 -- David V. Lu!! <davidvlu@gmail.com>  Wed, 21 May 2014 04:00:00 -0000

ros-r2b2-amcl (1.11.5-3xenial) xenial; urgency=high

  * Fix for #160 <https://github.com/ros-planning/navigation/issues/160>
  * Download test data from download.ros.org instead of willow
  * Change maintainer from Hersh to Lu

 -- David V. Lu!! <davidvlu@gmail.com>  Thu, 30 Jan 2014 05:00:00 -0000

ros-r2b2-amcl (1.11.4-3xenial) xenial; urgency=high

  * Package URL Updates
  * amcl_pose and particle cloud are now published latched
  * Fixed or commented out failing amcl tests.

 -- David V. Lu!! <davidvlu@gmail.com>  Fri, 27 Sep 2013 04:00:00 -0000

=== debian/control ===
Source: ros-r2b2-amcl
Section: misc
Priority: extra
Maintainer: David V. Lu!! <davidvlu@gmail.com>
Build-Depends: debhelper (>= 9.0.0), ros-r2b2-ament-cmake-auto, ros-r2b2-ament-cmake-ros, ros-r2b2-geometry-msgs, ros-r2b2-map-server, ros-r2b2-nav-msgs, ros-r2b2-rclcpp, ros-r2b2-rcutils, ros-r2b2-sensor-msgs, ros-r2b2-std-srvs, ros-r2b2-tf2, ros-r2b2-tf2-geometry-msgs, ros-r2b2-tf2-msgs, ros-r2b2-tf2-ros, ros-r2b2-ros-workspace
Homepage: http://wiki.ros.org/amcl
Standards-Version: 3.9.2

Package: ros-r2b2-amcl
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-r2b2-geometry-msgs, ros-r2b2-nav-msgs, ros-r2b2-rclcpp, ros-r2b2-rcutils, ros-r2b2-sensor-msgs, ros-r2b2-std-srvs, ros-r2b2-tf2, ros-r2b2-tf2-geometry-msgs, ros-r2b2-tf2-msgs, ros-r2b2-tf2-ros, ros-r2b2-ros-workspace
Description: amcl is a probabilistic localization system for a robot moving in 2D.
 It implements the adaptive (or KLD-sampling) Monte Carlo localization approach (as described by Dieter Fox), which uses a particle filter to track the pose of a robot against a known map. This node is derived, with thanks, from Andrew Howard's excellent 'amcl' Player driver.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/r2b2/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

# Build type specific exports if any.

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/r2b2/setup.sh" ]; then . "/opt/ros/r2b2/setup.sh"; fi && \
	dh_auto_configure -- -DCMAKE_INSTALL_PREFIX="/opt/ros/r2b2" -DAMENT_PREFIX_PATH="/opt/ros/r2b2"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/r2b2/setup.sh" ]; then . "/opt/ros/r2b2/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/r2b2/setup.sh" ]; then . "/opt/ros/r2b2/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/r2b2/setup.sh" ]; then . "/opt/ros/r2b2/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-r2b2-amcl//opt/ros/r2b2/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/r2b2/setup.sh" ]; then . "/opt/ros/r2b2/setup.sh"; fi && \
	dh_auto_install
